//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  C'0,125,0'
#property indicator_color2  C'0,140,0'
#property indicator_color3  C'0,155,0'
#property indicator_color4  C'0,170,0'
#property indicator_color5  C'0,185,0'
#property indicator_color6  C'0,200,0'
#property indicator_color7  C'0,215,0'
#property indicator_color8  C'0,230,0'
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern string TimeFrame  = "Current time frame";
extern int    RsiLength1 =  5;
extern int    RsiLength2 =  8;
extern int    RsiLength3 = 11;
extern int    RsiLength4 = 14;
extern int    RsiLength5 = 17;
extern int    RsiLength6 = 20;
extern int    RsiLength7 = 24;
extern int    RsiLength8 =  0;
extern int    RsiPrice   = PRICE_CLOSE;

double rsiBuffer1[];
double rsiBuffer2[];
double rsiBuffer3[];
double rsiBuffer4[];
double rsiBuffer5[];
double rsiBuffer6[];
double rsiBuffer7[];
double rsiBuffer8[];

int      timeFrame;
bool     returnBars;
string   indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsiBuffer1);
   SetIndexBuffer(1,rsiBuffer2);
   SetIndexBuffer(2,rsiBuffer3);
   SetIndexBuffer(3,rsiBuffer4);
   SetIndexBuffer(4,rsiBuffer5);
   SetIndexBuffer(5,rsiBuffer6);
   SetIndexBuffer(6,rsiBuffer7);
   SetIndexBuffer(7,rsiBuffer8);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" RSI fan");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { rsiBuffer1[0] = limit+1; return(0); }
           if (timeFrame != Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           
 	for(int i = limit; i>=0; i--)
 	{
 	    int y = iBarShift(NULL,timeFrame,Time[i]);
 	    if (RsiLength1>1)  rsiBuffer1[i] = iRSI(NULL,timeFrame,RsiLength1,RsiPrice,y);
 	    if (RsiLength2>1)  rsiBuffer2[i] = iRSI(NULL,timeFrame,RsiLength2,RsiPrice,y);
 	    if (RsiLength3>1)  rsiBuffer3[i] = iRSI(NULL,timeFrame,RsiLength3,RsiPrice,y);
 	    if (RsiLength4>1)  rsiBuffer4[i] = iRSI(NULL,timeFrame,RsiLength4,RsiPrice,y);
 	    if (RsiLength5>1)  rsiBuffer5[i] = iRSI(NULL,timeFrame,RsiLength5,RsiPrice,y);
 	    if (RsiLength6>1)  rsiBuffer6[i] = iRSI(NULL,timeFrame,RsiLength6,RsiPrice,y);
 	    if (RsiLength7>1)  rsiBuffer7[i] = iRSI(NULL,timeFrame,RsiLength7,RsiPrice,y);
 	    if (RsiLength8>1)  rsiBuffer8[i] = iRSI(NULL,timeFrame,RsiLength8,RsiPrice,y);
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}